#ifndef PARSER_HPP_
#define PARSER_HPP_

#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include <sstream>

class Parser{
  public:
    struct Arc{
      unsigned int source;  //source of the edge
      unsigned int target;  //target of the edge
      unsigned int capacity;  //capacity of the edge
    };

    unsigned int nodes[2];  //ids of source and target

    unsigned int num_nodes; //number of nodes in the graph
    
    std::vector<Arc> arcs;  //list of arcs

    Parser( const std::string & filename )
    {
      std::ifstream ifs( filename.c_str(), std::ios::in | std::ios::binary );
      std::string line;
      while( getline( ifs, line ) ){
        std::istringstream iss( line );
        char line_ident;
        iss >> line_ident;
        switch( line_ident ){         
          case 'c': /* comment line, do nothing */ break;
          case 'n': /* node line */
                {
                unsigned int id;
                char letter;
                iss >> id >> letter;
                nodes[letter-'s'] = id;
                }
                break;
          case 'a': /* arc line */
                {
                Arc arc;
                iss >> arc.source >> arc.target >> arc.capacity;
                arcs.push_back( arc );
                }
                break;
          case 'p': /* problem line */
                {
                std::string nirvana;
                unsigned int num_arcs;
                iss >> nirvana >> num_nodes >> num_arcs;
                arcs.reserve( num_arcs );
                }
                break;
        }
      }
    }
};


#endif
