/*
 * queryStaticDijkstra.cpp
 *
 *  Created on: May 17, 2011
 *      Author: kobitzsch
 */

#include "Parser.hpp"

//Ihre Implementierung
 #include "FlowImplementation.hpp"

//Timing
#include "timer.h"

#include <iostream>
#include <fstream>
#include <string>
#include <vector>

#include <cstdlib>
#include <getopt.h>

int main( int argc, char ** args ){
	std::vector<std::string> filenames;

	if( argc == 1 ){
		std::cout << "Usage: " << args[0] << std::endl;
		std::cout << "\t-g input-file" << std::endl;		
		return 0;
	}

    int c;
    while( (c = getopt( argc, args, "g:" ) ) != -1 ){
        switch( c ){
        case 'g':{
				filenames.push_back( optarg );
            }break;
        }
    }

	ClockCounterTimer timer( 3.0 * 1000000 );	//Muss durch Frequenz der Maschine ersetzt werden
	double sum = 0;
	for( unsigned int i = 0; i < filenames.size(); ++i ){
		Parser parser( filenames[i] );
		FlowImplementation flow_solver( parser );
		timer.start();
		unsigned int result = flow_solver.calculateFlow( parser.nodes[0], parser.nodes[1] );
		sum += timer.stop();
		std::cout << result << " ";
	}
	std::cout << " - time: " << sum / filenames.size() / 1000 << " seconds." << std::endl;

	return 0;
}
